#include <afc/easygui/easygui.h>
#include <afc/easygui/widgets.h>

int combo_sel ( DynamicClass * dc, EasyGUIContext * context, char * entry )
{
	fprintf ( stdout, "Combo Selected: %s\n", entry );

	return ( 0 );
}

int entry_txt ( DynamicClass * dc, EasyGUIContext * context, char * entry )
{
	fprintf ( stdout, "Text: %s\n", entry );

	/*
	afc_easygui_widget_execute ( context, "combo_menu", "unique", entry, AFC_EASYGUI_ARG_END );
	afc_easygui_widget_execute ( context, "combo_menu", "show", AFC_EASYGUI_ARG_END );
	*/

	afc_easygui_widget_execute ( context, "combo_menu", "set_text", entry, TRUE, AFC_EASYGUI_ARG_END );

	return ( 0 );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	EasyGUIContext * context;
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );
	context = afc_easygui_add_context ( easygui, NULL );

	afc_easygui_context_set_gui ( context, 
		"(window TITLE=\"EasyGUI: Combo\" MAINWIN "
		"	(eqrows "
		"		(combo name=\"combo_menu\"  items=\"Line 1|Line 2|Line 3|Line 4\" activate=\"combo_sel\" expand fill) "
		"		(cols EXPAND FILL "
		"			(label TEXT=\"Text To Insert\")"
		"			(entry name=\"entry_text\" action=\"entry_txt\")"
		"		)"
		"	) "
		") "
	);

	if ( ( afc_res = afc_easygui_context_show ( context ) ) != AFC_ERR_NO_ERROR ) 
	{
		fprintf ( stderr, "res: %x\n", afc_res );
	} else 
		afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );
	afc_delete ( afc );

	return ( 0 ); 
}
