#include <afc/easygui/easygui.h>
#include <afc/easygui/widgets.h>

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );

	afc_easygui_set_gui ( easygui, 
		"(window TITLE=\"EasyGUI: tabs galore\" MAINWIN "
		"	(tabs "
		"		(rows TABTITLE=\"Tab Number 1 [Buttons]\" "
		"			(button text=\"Button 1\" )"
		"			(button text=\"Button 2\" )"
		"			(button text=\"Button 3\" )"
		"		) "
		"		(rows TABTITLE=\"Second Tab [Checkboxes]\" "
		"			(checkbutton text=\"check me #1\" )"
		"			(checkbutton text=\"check me #2\" )"
		"			(checkbutton text=\"check me #3\" )"
		"		)"
		"		(rows TABTITLE=\"3rd Tab [Radio Buttons]\" "
		"			(radiobutton text=\"hello\" group=\"rad\" )"
		"			(radiobutton text=\"hello 2\" group=\"rad\" )"
		"			(radiobutton text=\"hello 3\" group=\"rad\" )"
		"		)"
		"	) "
		") "
	);

	if ( ( afc_res = afc_easygui_show ( easygui ) ) != AFC_ERR_NO_ERROR ) 
	{
		fprintf ( stderr, "res: %x\n", afc_res );
	} else 
		afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );
	afc_delete ( afc );

	return ( 0 ); 
}
