#include <afc/easygui/easygui.h>
#include <afc/easygui/widgets.h>

int btn_hello ( DynamicClass * dc, EasyGUIContext * context )
{
	fprintf ( stderr, "Hello World!\n" );
	return ( 0 );
}

int entry_activate ( DynamicClass * dc, EasyGUIContext * context, char * text )
{
	fprintf ( stderr, "You entered: %s\n", text );

	return ( 0 );
}

int toggle ( DynamicClass * dc, EasyGUIContext * context, int v )
{
	fprintf ( stderr, "Check Button is: %d\n", v );

	return ( 0 );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );

	afc_easygui_set_gui ( easygui, 
		"(window TITLE=\"EasyGUI: radiobutton\" MAINWIN "
                "	(rows "
		"		(toolbar name=pippo "
                "        		(button name=b4 TIP=\"This is the Hello Button\" ICON=\"gtk-copy\" action=btn_hello) "
                "        		(separator) "
                "        		(checkbutton name=GINO TIP=\"Check Button!\" ACTION=toggle TEXT=Hello!3 ) "
                "        		(entry name=ttt maxlen=10 activated=entry_activate ) "
		"		) "
		"	)"
		") "
	);

	if ( ( afc_res = afc_easygui_show ( easygui ) ) != AFC_ERR_NO_ERROR ) 
	{
		fprintf ( stderr, "res: %x\n", afc_res );
	} else 
		afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );
	afc_delete ( afc );

	return ( 0 ); 
}
