#include "../easygui.h"
#include "../widgets.h"

int opt_menu_changed ( DynamicClass * dc, EasyGUIContext * context, int selected )
{
	printf ( "Option Menu, selected: %d\n", selected );
	return ( 0 );
}

int entry_activate ( DynamicClass * dc, EasyGUIContext * context, const char * text )
{
	fprintf ( stderr, "Entry Activated: %s\n", text );

	afc_easygui_widget_execute ( context, "optm", "set", atoi ( text ), AFC_EASYGUI_ARG_END );

	return ( 0 );
}

int win_activated ( DynamicClass * dc, EasyGUIContext * context )
{
	printf ( "Win Activate\n" );
	afc_easygui_widget_execute ( context, "optm", "set", 1, AFC_DYNAMIC_CLASS_ARG_END );

	return ( 0 );
}

int main ( int argc, char * argv[] )
{
	AFC * afc = afc_new (); 
	EasyGUI * easygui = afc_easygui_new ( afc );
	EasyGUIContext * context;
	int afc_res = 0;

	if ( easygui == NULL ) 
	{
	  fprintf ( stderr, "Init of class EasyGUI failed.\n" );
	  return ( 1 );
	}

	afc_easygui_init ( easygui );
	context = afc_easygui_add_context ( easygui, AFC_EASYGUI_CONTEXT_MAIN );

	afc_easygui_context_set_gui_from_file ( context, "gui_optmenu.egui" );

	// afc->debug_level = AFC_DEBUG_EVERYTHING; 

	if ( ( afc_res = afc_easygui_context_show ( context ) ) != AFC_ERR_NO_ERROR ) {
		fprintf ( stderr, "res: %x\n", afc_res );
	}
	else afc_easygui_main ( easygui );

	afc_easygui_delete ( easygui );

	afc_delete ( afc );

	return ( 0 ); 
}
