/* AFC - The  Advanced Foundation Classes
 * Copyright (C) 2000/2004  Fabio Rotondo - Andrea Galimberti
 *  
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *  
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef AFC_EASYGUI_TCLIST_H
#define AFC_EASYGUI_TCLIST_H

#include <gtk/gtk.h>

#include "../easygui.h"
#include "../widgets.h"
#include "../glob_methods.h"

// CList custom Attributes
#define AFC_EASYGUI_TCLIST_ATTR_SHOW_TITLES	1

// INTERNAL DEFINES - DO NOT USE IN YOUR CODE!
#define AFC_TCLIST_STORE_DYNCLASS(widg,dc)	g_object_set_data ( G_OBJECT ( widg ), "dynamic_class_addr", dc )
#define AFC_TCLIST_GET_DYNCLASS(widg,dc)		dc = g_object_get_data ( G_OBJECT ( widg ), "dynamic_class_addr" )
#define AFC_TCLIST_GET_CLDATA(dc,cldata)		cldata = afc_dynamic_class_get_var ( dc, "cldata" )

struct easygui_tclist_data
{
	GtkWidget	 * scrollwin;	// The ScrollWindow container
	GtkListStore 	 * model;	// CList Model Data
	GtkTreeSelection * selection;	// CList selection
	GtkWidget 	 * view;	// The View (CList) widget

	int		   columns;	// Number of columns

	char 	 * * col_data;	// Data contained in columns
};

typedef struct easygui_tclist_data EGTCListData;

DynamicClass * afc_easygui_internal_tclist_new_instance ();
int afc_easygui_internal_tclist_del_instance ( DynamicClass * );

// Signals Prototype
typedef int ( * EasyGUITCListSignalFunc ) ( DynamicClass * dc, EasyGUIContext * context, char * * col_values, void * info );
typedef short ( * EasyGUITCListSelectSignalFunc ) ( DynamicClass * dc, EasyGUIContext * context, short previously_selected, char * * col_values, void * info );


#endif
