/* AFC - The Advanced Foundation Classes
 * Copyright (C) 2001 - 2002 Fabio Rotondo and Andrea Galimberti
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include "../test_utils.h"

int dump_all ( ArrayMaster * am, int c )
{
	int t;

	afc_array_master_before_first ( am );

	while ( ( t = ( int ) afc_array_master_next ( am ) ) ) printf ( "Val: %d\n", t );

	return ( AFC_ERR_NO_ERROR );
}

int main ()
{
	AFC * afc = afc_new ();
	ArrayMaster * am = afc_array_master_new ( );
	int t;

	for ( t = 1; t <= 10; t ++ ) afc_array_master_add ( am, ( void * ) t, AFC_ARRAY_MASTER_ADD_TAIL );

	dump_all ( am, t  );

	afc_delete ( afc );

	return ( 0 );
}
