/* AFC - The Advanced Foundation Classes
 * Copyright (C) 2001 - 2002 Fabio Rotondo and Andrea Galimberti
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include <stdlib.h>

#include "../test_utils.h"

int elements = 0;

Dictionary * dic;

int main ()
{
	AFC * afc = afc_new ();
	char * str, * s;
	int t;

	if ( afc == NULL ) return ( 1 );

	dic = afc_dictionary_new ();
	str = afc_string_new ( 30 );

	test_header ();


	for ( t = 0; t < 20; t ++ )
	{
		afc_string_make ( str, "%d", t );	
		afc_dictionary_set ( dic, str, afc_string_dup ( str ) );
	}

	for ( t = 0; t < 20; t ++ )
	{
		afc_string_make ( str, "%d", t );
		s = afc_dictionary_get ( dic, str );
		print_res ( "get()", str,  s, 1 );

		afc_dictionary_set ( dic, str, NULL );

		afc_string_delete ( s );
	}

	print_row ();
	print_summary ();

	afc_dictionary_delete ( dic );
	afc_string_delete ( str );
	afc_delete ( afc );

	return ( 0 );
}

